﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        DataSet set = new DataSet();
        //Add two tables
        set.Tables.Add(BuildTable("Parent"));
        set.Tables.Add(BuildChildTable("Child"));

        //Create relations
        DataColumn parentColumn = set.Tables[0].Columns["id"];
        DataColumn childColumn = set.Tables[1].Columns["relation"];
        DataRelation relation = new DataRelation("RelationName", parentColumn, childColumn);
        set.Relations.Add(relation);

        this.WebHierarchicalDataGrid1.DataSource = set;
    }  



    private DataTable BuildTable(string name)
    {
       
        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }

  private DataTable BuildChildTable(string name)
    {
        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "relation";
        column.AutoIncrement = false;
        column.Caption = "relation";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 100; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = name +" Item " + i;
            row["Data"] = name +"Data " + i;

            if ((i < 10) && (i >= 0))
            {

                row["relation"] = 0;
            }
            else if ((i < 20) && (i >= 10))
            {
                row["relation"] = 1;
            }
            else if ((i < 30) && (i >= 20))
            {
                row["relation"] = 2;
            }
            else if ((i < 40) && (i >= 30))
            {
                row["relation"] = 3;
            }
            else if ((i < 50) && (i >= 40))
            {
            }
            table.Rows.Add(row);
        }
        return table;

    }

  protected void WebHierarchicalDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
  {
      ((ContainerGridRecord)e.Row).IsEmptyParent = true;
  }
  protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, ContainerRowCancelEventArgs e)
  {
      e.Cancel = true;

      ContainerGrid childGrid = new ContainerGrid();
      if (e.Row.RowIslands.Count == 0)
      {
          e.Row.RowIslands.Add(childGrid);
      }
      else
      {
          childGrid = e.Row.RowIslands[0];
      }

      if (e.Row.Items.FindItemByKey("unbound").Value != null)
      {
          childGrid.DataSource = BuildChildTable(e.Row.Items.FindItemByKey("unbound").Value.ToString());
      }
  }
  protected void btn_child1_Click(object sender, EventArgs e)
  {
      Button btn = (Button)sender;
      GridRecordItem item = (GridRecordItem)((Infragistics.Web.UI.TemplateContainer)(((System.Web.UI.Control)(btn)).Parent)).Item;
      (item.Row).Items.FindItemByKey("unbound").Value = "Child1";

  }
  protected void btn_child2_Click(object sender, EventArgs e)
  {
      Button btn = (Button)sender;
      GridRecordItem item = (GridRecordItem)((Infragistics.Web.UI.TemplateContainer)(((System.Web.UI.Control)(btn)).Parent)).Item;
      (item.Row).Items.FindItemByKey("unbound").Value = "Child2";
  }
}